<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
	<div>
		<el-dialog :title="title" :close-on-click-modal="false" draggable width="1200px" height="500px" @close="close"
			append-to-body v-model="visible">
			<el-form :model="inputForm" ref="inputForm" v-loading="loading" :rules="rules"
				:class="method === 'view' ? 'readonly' : ''"
				:disabled="status === 'audit' || status === 'taskFormDetail' || method === 'view'" label-width="100px"
				@submit.native.prevent>
				<el-row :gutter="26">
					<el-col :span="12">
						<el-form-item label="项目名称" prop="name">
							<el-input v-model="inputForm.name" placeholder="请输入项目名称"></el-input>
						</el-form-item>
					</el-col>

					<el-col :span="12">
						<el-form-item label="委托方" prop="client">
							<el-input v-model="inputForm.client" placeholder="请输入委托方"></el-input>
						</el-form-item>
					</el-col>

					<el-col :span="12">
						<el-form-item label="工程分类" prop="type">
							<el-input v-model="inputForm.type" placeholder="请输入类型"></el-input>
						</el-form-item>
					</el-col>

					<el-col :span="12">
						<el-form-item label="规模类型/单位/数量" prop="info">
							<el-input v-model="inputForm.info" placeholder="请输入信息"></el-input>
						</el-form-item>
					</el-col>

					<el-col :span="12">
						<el-form-item label="担任职务" prop="position">
							<el-select size="default" v-model="inputForm.position" placeholder="请选择担任的职务"
								style="width: 100%;">
								<el-option v-for="item in $dictUtils.getDictList('position_held')" :key="item.value"
									:label="item.label" :value="item.value">
								</el-option>
							</el-select>
						</el-form-item>
					</el-col>

					<el-col :span="24">
						<el-form-item label="参与内容" prop="participateContent">
							<el-input type="textarea" v-model="inputForm.participateContent"
								placeholder="请输入参与内容"></el-input>
						</el-form-item>
					</el-col>
				</el-row>
			</el-form>
			<template #footer>
				<span class="dialog-footer">
					<el-button @click="close()" icon="el-icon-circle-close">关闭</el-button>
					<el-button v-if="method === 'edit' || method == 'add'" type="primary" icon="el-icon-circle-check"
						@click="doSubmit()">暂存</el-button>
				</span>
			</template>
		</el-dialog>
	</div>
</template>

<script>
import enrollmentRegistrationService from '@/api/human/enrollment/EnrollmentRegistrationService'
export default {
	props: {
		businessId: {
			type: String,
			default: ''
		},
		formReadOnly: {
			type: Boolean,
			default: false
		},
		status: {
			type: String,
			default: ''
		}
	},
	data() {
		return {
			disabled: false,
			title: '',
			method: '',
			visible: false,
			loading: false,
			inputForm: {
				id: "",
				enrollmentRegistrationId: '',
				name: "",
				client: "",
				type: "",
				info: "",
				position: "",
				participateContent: "",
				status: "",
			},
			keyWatch: '',
			rules: {
				name: [
					{ required: true, message: '请输入职务名称', trigger: 'blur' },
				],
			},
		}
	},
	created() {
	},
	components: {
	},
	computed: {
		bus: {
			get() {
				return this.businessId
			},
			set(val) {
				this.businessId = val
			}
		},
		name() {
			return this.$store.state.user.name
		},
		userId() {
			return this.$store.state.user.id
		}
	},
	watch: {
		'keyWatch': {
			handler(newVal) {
				if (this.commonJS.isNotEmpty(this.bus)) {
					this.init('', this.bus)
				} else {
					this.$nextTick(() => {
						this.$refs.inputForm.resetFields()
					})
				}
			}
		},
		'loading': {
			handler(newVal) {
				this.$emit('changeLoading', newVal)
			}
		}
	},
	methods: {
		getKeyWatch(keyWatch) {
			this.keyWatch = keyWatch
		},
		init(method, id, reId) {
			this.method = method
			this.inputForm = {
				id: "",
				enrollmentRegistrationId: '',
				name: "",
				client: "",
				type: "",
				info: "",
				position: "",
				participateContent: "",
				status: "",
			}
			if (method === 'add') {
				this.title = `新增工作业绩`
			} else if (method === 'edit') {
				this.title = '修改工作业绩'
			} else if (method === 'view') {
				this.title = '查看工作业绩'
			}
			this.inputForm.userId = reId
			this.visible = true
			this.loading = true
			this.$nextTick(() => {
				if (id) {
					enrollmentRegistrationService.findPerformanceInfoById({
						id: id
					}).then(res => {
						this.inputForm = this.recover(this.inputForm, res)
						this.inputForm = JSON.parse(JSON.stringify(this.inputForm))
						this.loading = false
					})
				} else {
					this.loading = false
				}
			})
		},
		generateFallbackId() {
			const timestamp = Date.now(); // 13位
			const randomPart = Math.floor(Math.random() * 1e6); // 6位随机数
			return String(timestamp) + String(randomPart);  // 返回 19 位字符串
		},
		// 表单提交
		doSubmit() {
			this.$refs['inputForm'].validate((valid) => {
				if (valid) {
					// this.$emit("addPerformanceInfo", JSON.parse(JSON.stringify(this.inputForm)))
					// this.close()


					if (this.inputForm.id && this.inputForm.status != "1" && this.inputForm.status != "4") {
						enrollmentRegistrationService.updateInfoStatus({
							id: this.inputForm.id,
							status: "6",
							type: "10"
						}).then(result => {
							// 暂存状态
							this.inputForm.id = ""
							this.inputForm.status = 1
							enrollmentRegistrationService.savePerformanceInfo(this.inputForm).then(res => {
								this.$message.success(res)
								this.$emit("addPerformanceInfo", this.inputForm.enrollmentRegistrationId)
								this.loading = false
								this.close()
							})
						})
					} else {
						console.log(this.inputForm.id);
						console.log(this.inputForm.status);
						// 暂存状态
						this.inputForm.status = 1
						enrollmentRegistrationService.savePerformanceInfo(this.inputForm).then(res => {
							this.$message.success(res)
							this.$emit("addPerformanceInfo", this.inputForm.enrollmentRegistrationId)
							this.loading = false
							this.close()
						})
					}


				}
			})
		},
		close() {
			this.$refs.inputForm.resetFields()
			this.visible = false
		},
	}
}
</script>


<style lang="less">
.fileUpload {
	.el-form-item__content {
		width: 100%;
	}
}
</style>
